//+------------------------------------------------------------------+
//|                                     ChartWindowDiagonalLines.mq4 |
//|                                          Copyright 2022 mql5.com |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022 mql5.com"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

input color                Lines_Color      = clrChocolate;
input ENUM_LINE_STYLE      Lines_Style      = STYLE_SOLID;
input int                  Lines_Width      = 2;
input bool                 Plot_Half_Lines  = true;

double   price1,price2;
datetime t1,t2;
int      ChartHeight,ChartWidth,x,y;
int      window=0;
string   Indi_ID = "CWDL";
string   Line1Name = Indi_ID+"_Diagonal_Line_BottomLeft_";
string   Line2Name = Indi_ID+"_Diagonal_Line_TopLeft_";
string   Line3Name = Indi_ID+"_Half_Line_Horizontal_";
string   Line4Name = Indi_ID+"_Half_Line_Vertical_";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
                ChartHeight=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
                ChartWidth=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
                x=0; y=0;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line1Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                x=0; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=0;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line2Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                if(Plot_Half_Lines)
                 {
                x=0; y=ChartHeight/2;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=ChartHeight/2;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line3Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                x=ChartWidth/2; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth/2; y=0;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line4Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                 }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
                ChartHeight=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
                ChartWidth=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
                x=0; y=0;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line1Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                x=0; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=0;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line2Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                if(Plot_Half_Lines)
                 {
                x=0; y=ChartHeight/2;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth; y=ChartHeight/2;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line3Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                x=ChartWidth/2; y=ChartHeight;
                ChartXYToTimePrice(0,x,y,window,t1,price1);
                x=ChartWidth/2; y=0;
                ChartXYToTimePrice(0,x,y,window,t2,price2);
                CreateTrendline(Line4Name,price1,price2,t1,t2,Lines_Color,Lines_Style,Lines_Width);
                 }
                
                ChartRedraw();
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
               objectsDelete(Indi_ID);
               ChartRedraw(ChartID());
//----
  }
//+------------------------------------------------------------------+
void objectsDelete(string name)
{
   int objTotal = ObjectsTotal(ChartID());
   for(int i=objTotal-1; i>=0; i--)  
  {
      string objName = ObjectName(ChartID(),i);
      if(StringFind(objName,name,0) >= 0)
       ObjectDelete(0,objName);
   }
}
//+------------------------------------------------------------------+
void CreateTrendline(string name,double dprice1,double dprice2,datetime dt1,datetime dt2,color paint,int style,int width) 
   {
      if(ObjectFind(0,name)<0)
      ObjectCreate(0,name, OBJ_TREND, 0, 0, 0);
      ObjectSetDouble(0,name, OBJPROP_PRICE1, dprice1);
      ObjectSetDouble(0,name, OBJPROP_PRICE2, dprice2);
      ObjectSetInteger(0,name, OBJPROP_TIME1, dt1);
      ObjectSetInteger(0,name, OBJPROP_TIME2, dt2);
      ObjectSetInteger(0,name, OBJPROP_COLOR, paint);
      ObjectSetInteger(0,name, OBJPROP_STYLE, style);
      ObjectSetInteger(0,name, OBJPROP_WIDTH, width);
      ObjectSetInteger(0,name, OBJPROP_BACK, false);
      ObjectSetInteger(0,name, OBJPROP_RAY, false);
      ObjectSetInteger(0,name, OBJPROP_SELECTED, false);
      ObjectSetInteger(0,name, OBJPROP_SELECTABLE, false);
   }
//-------------------------------------------------------------------+
